<?php
namespace Claromentis\People\Filter;

$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] ?: array()) + array("_1f50e30be8c2fefa6881834e" . "71d504a2" => base64_decode("b2Z" . "mc2" . "V0"), "_f11369824f533e" . "8206f9ccc0c9aab" . "3a0" => base64_decode("bG" . "lt" . "aX" . "Q="), "_680cc2b8220e94c8c32b8bc7c655" . "19b4" => base64_decode("aXN" . "faW" . "50"));
use Claromentis\Core\Security\SecurityContext;
use Psr\Http\Message\ServerRequestInterface;







abstract class AbstractPeopleFilter
{
    
    
    public $context;
    const DEFAULT_LIMIT = 20;
    const MAX_LIMIT = 200;
    
    
    protected $limit = self::DEFAULT_LIMIT;
    
    
    protected $offset = 0;
    public function __construct(SecurityContext $context)
    {
        $this->context = $context;
    }
    public function IsPaginationSet()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_680cc2b8220e94c8c32b" . "8bc7c65519b4"]($this->limit) && $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_680cc2b8220e94" . "c8c32b8bc7c6551" . "9b4"]($this->offset);
    }
    
    
    
    
    
    
    
    
    
    
    public function GetPublicDefaults() : array
    {
        return [$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f11369824f533e8206" . "f9ccc0c9aab3a0"] => $this->limit, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_1f50e30" . "be8c2fef" . "a6881834" . "e71d504a" . "2"] => $this->offset];
    }
    
    
    
    
    
    
    
    
    public function SetPaginationAttributesFromRequest(ServerRequestInterface $request) : void
    {
        $this->SetOffset($request->getAttribute($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_1f50e30be8c2fefa6881" . "834e71d504a2"], 0));
        $this->SetLimit($request->getAttribute($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_f1136982" . "4f533e820" . "6f9ccc0c9" . "aab3a0"], self::DEFAULT_LIMIT));
    }
    
    
    
    
    
    
    public function SetLimit(int $_f11369824f533e8206f9ccc0c9aab3a0) : void
    {
        if (!$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_680cc2b8220e94c8c32b8bc7c65519" . "b4"]($_f11369824f533e8206f9ccc0c9aab3a0) || $_f11369824f533e8206f9ccc0c9aab3a0 <= 0) {
            return;
        }
        if ($_f11369824f533e8206f9ccc0c9aab3a0 > self::MAX_LIMIT) {
            $_f11369824f533e8206f9ccc0c9aab3a0 = self::MAX_LIMIT;
        }
        $this->limit = $_f11369824f533e8206f9ccc0c9aab3a0;
    }
    
    
    
    
    
    
    public function SetOffset(int $_1f50e30be8c2fefa6881834e71d504a2) : void
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_680cc2b8220e94c8c32b" . "8bc7c65519b4"]($_1f50e30be8c2fefa6881834e71d504a2) || $_1f50e30be8c2fefa6881834e71d504a2 < 0) {
            return;
        }
        $this->offset = $_1f50e30be8c2fefa6881834e71d504a2;
    }
    
    
    
    
    public function Limit() : int
    {
        return $this->limit;
    }
    
    
    
    
    public function Offset() : int
    {
        return $this->offset;
    }
}